#include <iostream>
#include <cstdio>
#include <cstring>
#define mod  998244353
using namespace std;
typedef long long lli;

char a[1010][1010];
//
lli check_c(lli i,lli j)
{
    lli s=0;
    while(a[i][j]=='0'){s++;j++;}
    return (s);
}
//
lli check_f(lli i,lli j)
{
    lli s=0;
    while(a[i][j]=='0'){s++;i++;}
    return (s);
}
//
int main()
{
    freopen("plant.in","r",stdin);
    freopen("plant.out","w",stdout);
    lli T,id,t,n,m,c,f,i,j,vc=0,vf=0,I,J,c1,c2,f1,x;
    cin>>T>>id;
    for(t=0;t<T;t++)
    {
        cin>>n>>m>>c>>f;
        for(i=1;i<=n;i++)
        {
            for(j=1;j<=m+1;j++)
            {
                a[i][j]=getchar();
            }
        }
        for(I=1;I<=n;I++)
        {
            for(J=2;J<m+1;J++)
            {
                c1=check_c(I,J);
                if(c1<2){continue;}
                f1=check_f(I,J);
                if(f1<3){continue;}
                for(i=2;i<f1;i++)
                {
                    c2=check_c(I+i,J);
                    x=((c1-1)*(c2-1))%mod;
                    vc=(vc+x)%mod;
                    vf=(vf+(x*(f1-i-1))%mod)%mod;
                }
            }
        }
        vc=c*vc;
        vf=f*vf;
        cout<<vc<<" "<<vf<<endl;
    }
    return 0;
}
